/*
* mav.c
* memory allocation visualization
* Luiz Henrique de Figueiredo & Waldemar Celes
* 21 Mar 2003 18:24:57
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include "gp.h"

enum { FREE = 10, REALLOC, MALLOC };

static int M=1024, S=8;

static void box(int xmin, int xmax, int ymin, int ymax)
{
 if(1)printf("box %d %d %d %d\n",xmin,xmax,ymin,ymax);
 dvbox(S*xmin,S*xmax+S-1,S*ymin,S*ymax+S-1);
}

static void fill(int c, int address, int size)
{
 static int base=-1;
 int x0,y0,x1,y1;
 if (base<0) base=address;
 address-=base;
 printf("fill %d %d\n",address,size);
 address/=8;
 x0= address % M; y0= address / M;
 if(1)printf("start %d %d %d\n",address,x0,y0);
 address+=(size+(size%8))/8;
 x1= address % M; y1= address / M;
 if(1)printf("end   %d %d %d\n",address,x1,y1);
 dvcolor(c);
 if (y1-y0>0) box(x0,M-1,y0,y0); else box(x0,x1,y0,y0);
 if (y1-y0>1) box(0,M-1,y0+1,y1-1);
 if (y1-y0>0) box(0,x1,y1,y1);
}

int main(void)
{
  char s[200];
  sprintf(s, "GP=%dx%d", M, 700);
  putenv(s);
  dvopen("mav");
  dvpalette(0, "black");
  dvpalette(1, "white");
  dvpalette(2, "red");
  dvpalette(FREE, "grey");
  dvpalette(MALLOC, "gold");
  dvpalette(REALLOC, "orange");
  M/=S;
   dvwait(-1);
  while (fgets(s,sizeof(s),stdin))
  {
   int type, address, size;
   fputs(s,stdout);
   sscanf(s,"%*c %d %d",&address,&size);
   fill(2,address,size);
   dvwait(1);
   switch (s[0])
   {
    case 'f':
     fill(FREE,address,size);
     break;
    case 'r':
     fill(REALLOC,address,size);
     break;
    case 'm':
     fill(MALLOC,address,size);
     break;
   }
   dvwait(1);
  }
  dvdump(0);
  dvclose(1);
  return 0;
}
